////////////////////////////////////////////////
//                                            //
// Super Trace macros                         //
// written by Ehsan Akhgari                   //
//  Comtact me at Ehsan@BeginThread.com       //
//  http://www.beginthread.com/ehsan/         //
//                                            //
////////////////////////////////////////////////

#ifndef __AFX_H__
#error This header should be included after afx.h
#endif

#ifdef _DEBUG // debug version of the macros

#define SuperTRACE ::AfxTrace( _T("%s(%d): "), __FILE__, __LINE__ ); \
	::AfxTrace

#define SuperTRACE0(sz) SuperTRACE( _T("%s"), _T(sz) )

#define SuperTRACE1(sz, p1) SuperTRACE( _T(sz), p1 )

#define SuperTRACE2(sz, p1, p2) SuperTRACE( _T(sz), p1, p2 )

#define SuperTRACE3(sz, p1, p2, p3) SuperTRACE( _T(sz), p1, p2, p3 )

#else // release version of macros

#define SuperTRACE 1 ? ((void) 0) : ::AfxTrace

#define SuperTRACE0(sz)

#define SuperTRACE1(sz, p1)

#define SuperTRACE2(sz, p1, p2)

#define SuperTRACE3(sz, p1, p2, p3)

#endif

// replace MFC's TRACE macros

#ifdef TRACE
#undef TRACE
#endif

#ifdef TRACE0
#undef TRACE0
#endif

#ifdef TRACE1
#undef TRACE1
#endif

#ifdef TRACE2
#undef TRACE2
#endif

#ifdef TRACE3
#undef TRACE3
#endif

#define TRACE SuperTRACE

#define TRACE0 SuperTRACE0

#define TRACE1 SuperTRACE1

#define TRACE2 SuperTRACE2

#define TRACE3 SuperTRACE3
